/*____________________________________________________________________________
	CEncryptTranslator.c
	
	Copyright (C) 1997 Network Associates, Inc. and its affiliates.
	All rights reserved.
	
	

	$Id: CEncryptTranslator.h,v 1.4.8.1 1998/11/12 03:06:32 heller Exp $
____________________________________________________________________________*/
#pragma once


#include "CTranslator.h"

struct PGPKeySpec;

class CEncryptTranslator : public CTranslator
{
protected:
	CipherOutputType	mOutputType;
	Boolean				mDoSign;
	
public:
				CEncryptTranslator(
					PGPContextRef	context, PGPtlsContextRef tlsContext,
					emsProgress	progressHook,
					CipherOutputType outputType = kUseOldPGPFormat,
					Boolean doSign = false );
	
	virtual PluginError	TranslateFile( long transContext, 
							ConstemsMIMETypeHandle InMIMEtypeHandle,
							const FSSpec * inFSp,
							StringHandle** addressesHandle,
							emsMIMETypeHandle *	OutMIMEtypeHandlePtr,
							const FSSpec * outFSp,
							StringHandle* returnedMessage,
							StringHandle* errorMessage,
							long * resultCode);
};
